; tabstop=8
;
;
	ORG	0E000H

	JP	INTMASK
	JP	INIT8251
	JP	TXDATA
	JP	TXQUICK
	JP	RXDATA
	JP	RXQUICK

MODE8251:
	DB	4FH		; stop=1/parity=none/length=8bit/clock=x64
DTSTART:
	DW	0000H
DTSIZE:
	DW	4000H
STATUSFLAG:
	DB	00H		; DSR/BD/FE/OE/PE/TXEMPTY/RXRDY/TXRDY
TXMODE:
	DB	81H		; DSR=on/TxRDY=1
RXMODE:
	DB	02H		; RxRDY=1

INTMASK:
	DI
	LD	HL,RS232C_INTVEC
	LD	(0FA04H),HL	; RS232C̊荞݂XLbv
RS232C_INTVEC:
	EI
	RET

INIT8251:
	DI
	LD	A,(MODE8251)
	LD	B,A
	LD	A,12H
	OUT	(81H),A		; RTS=off/DTR=on/Tx=Disable/Rx=Disable/Error clear
	LD	A,52H
	OUT	(81H),A		; 8251 Reset
	NOP			; wait
	NOP
	NOP
	NOP
	LD	A,B
	OUT	(81H),A		; 8251 mode set
	LD	A,37H
	OUT	(81H),A		; RTS=on/DTR=on/Tx=Enable/Rx=Ensable/Error clear
	EI
	RET


TXDATA:
	DI
	LD	HL,(DTSTART)
	LD	DE,(DTSIZE)
	XOR	A
	LD	(STATUSFLAG),A
	LD	A,(TXMODE)
	LD	B,A
TX_L1:
	IN	A,(81H)
	AND	B
	CP	B
	JR	NZ,TX_L1
	LD	A,(HL)
	OUT	(80H),A
	INC	HL
	DEC	DE
	LD	A,D
	OR	E
	JR	Z,TX_END
TX_L2:
	IN	A,(81H)		; get TxRDY & DSR status
	AND	B
	CP	B
	JR	NZ,TX_L2
	LD	A,(HL)
	LD	C,81H
	IN	C,(C)		; get TxEMPTY status
	OUT	(80H),A
	LD	A,(STATUSFLAG)
	OR	C
	LD	(STATUSFLAG),A
	INC	HL
	DEC	DE
	LD	A,D
	OR	E
	JR	NZ,TX_L2
TX_END:
	EI
	RET


TXQUICK:
	DI
	LD	A,02H
	OUT	(93H),A
	LD	HL,(DTSTART)
	LD	BC,(DTSIZE)
	LD	E,B
	LD	B,C
	LD	C,80H
	LD	D,00H

TQ_L1:
	IN	A,(81H)		; 11+1
	RRCA			; 4+1
	JR	NC,TQ_L1	; 7+1  / 12+1

	OUTI			; 16+2
	JR	NZ,TQ_L2	; 7+1  / 12+1
	DEC	E		; 4+1
	JR	Z,TQ_END	; 7+1  / 12+1

TQ_L2:
	XOR	A		; 4+1
TQ_L4:
	OR	D		; 4+1
	LD	D,A		; 4+1
				; 10
TQ_L3:
	IN	A,(81H)		; 11+1
	RRCA			; 4+1
	JR	NC,TQ_L3	; 7+1  / 12+1
				; 25

	IN	A,(81H)		; 11+1
	OUTI			; 16+2
	JR	NZ,TQ_L4	; 7+1  / 12+1
	DEC	E		; 4+1
	JP	NZ,TQ_L4	; 10+1
				; 48

TQ_END:
	LD	A,D
	LD	(STATUSFLAG),A
	LD	A,03H
	OUT	(93H),A
	EI
	RET


RXDATA:
	DI
	LD	HL,(DTSTART)
	LD	BC,(DTSIZE)
	LD	A,(RXMODE)
	LD	D,A
	LD	A,37H
	OUT	(81H),A		; ERROR clear / RTS=on
RX_L2:
	LD	A,27H
	OUT	(81H),A		; RTS=on
RX_L1:
	IN	A,(81H)
	AND	D
	CP	D
	JR	NZ,RX_L1
	LD	A,07H
	OUT	(81H),A		; RTS=off
	IN	A,(80H)
	LD	(HL),A
	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,RX_L2
	IN	A,(81H)
	LD	(STATUSFLAG),A
	LD	A,37H
	OUT	(81H),A		; ERROR clear / RTS=on
	EI
	RET


RXQUICK:
	DI
	LD	A,02H
	OUT	(93H),A
	LD	HL,(DTSTART)
	LD	BC,(DTSIZE)
	LD	E,B
	LD	B,C
	LD	D,02H
	LD	C,80H
	LD	A,37H
	OUT	(81H),A		; ERROR clear / RTS=on
	LD	A,27H
	OUT	(81H),A		; RTS=on

RQ_L1:
	IN	A,(81H)		; 11+1
	AND	D		; 4+1
	JR	Z,RQ_L1		; 7+1  / 12+1
				; 25

	INI			; 16+2
	JR	NZ,RQ_L1	; 7+1  / 12+1
	DEC	E		; 4+1
	JP	NZ,RQ_L1	; 10+1
				; 36

	IN	A,(81H)
	LD	(STATUSFLAG),A

	LD	A,37H
	OUT	(81H),A		; ERROR clear / RTS=on

	LD	A,03H
	OUT	(93H),A

	EI
	RET


